#include <stdint.h>
#include "r_meter.h"

//sbits
sbit S1             at PORTD4_bit;
sbit S1_DIR         at DDD4_bit;
sbit S2             at PORTD2_bit;
sbit S2_DIR         at DDD2_bit;
sbit S3             at PORTA6_bit;
sbit S3_DIR         at DDA6_bit;
sbit R_METER_CS     at PORTA5_bit;
sbit R_METER_CS_DIR at DDA5_bit;

//Prototypes
void system_setup( void );

//Main
void main( void )
{
    //Local Declarations
    char txt[20] = { 0 };
    float ohms_var = 0;

    //Setup
    system_setup();

    while (1)
    {
        ohms_var = r_meter_get_ohms();
        if ( ohms_var == 0 )
            UART1_Write_Text( "Over Range\r\n" );
        else
        {
            FloatToStr( ohms_var, txt );
            UART1_Write_Text( "OHMS: " );
            UART1_Write_Text( txt );
            UART1_Write_Text( "\r\n" );
        }
        delay_ms(250);
    }
}

void system_setup( void )
{
    // GPIOs
    S1_DIR = 1;
    S2_DIR = 1;
    S3_DIR = 1;
    R_METER_CS_DIR = 1;

    //UART
    UART1_Init(9600);                      // Initialize UART module at 9600 bps
    Delay_ms(100);                         // Wait for UART module to stabilize
    UART1_Write_Text( "Starting\r\n" );
    //ADC
    ADC_Init();
    Delay_ms(200);
    UART1_Write_Text( "UART Initialized\r\n" );

}